#pragma once

struct Material {
    float fShininess;
    float fAmbientIntensity;
    float fDiffuseIntensity;
    vec4 vAmbient;
    vec4 vSpecular;
    int iFlags;
};

struct MaterialFlags {
    bool bDisableLighting;
    bool bEnableEnvReflection;
    bool bEnableEnvRefraction;
    bool bUseNormalTexture;
    bool bUseHeightTexture;
};

void decodeMaterialFlags(int encodedFlags, inout MaterialFlags decodedFlags) {
     decodedFlags.bDisableLighting = bool(encodedFlags >> 0 & 1);
     decodedFlags.bEnableEnvReflection = bool(encodedFlags >> 1 & 1);
     decodedFlags.bEnableEnvRefraction = bool(encodedFlags >> 2 & 1);
     decodedFlags.bUseNormalTexture = bool(encodedFlags >> 4 & 1);
     decodedFlags.bUseHeightTexture = bool(encodedFlags >> 5 & 1);
}