#pragma once

struct LightBase
{
    vec4 vColor;
    float fAmbientIntensity;
    float fDiffuseIntensity;
    float fSpecularIntensity;
};

struct Attenuation
{
    float fConstant;
    float fLinear;
    float fQuadric;
};

struct PointLightBase
{
    LightBase lightBase;
    vec3 vPosition;
    Attenuation attenuation;
    bool bUseAttenuation;
    float fDistance;
    float fShadowDistance;
    bool bCastShadows;
};

struct PointLight
{
    PointLightBase pointLightBase;
};

struct DirectionalLight
{
    PointLightBase pointLightBase;
    vec3 vDirection;
    mat4 mLightSpaceTransform;
};

struct SpotLight
{
    DirectionalLight directionalLightBase;
    float fCutOff;
    float fOuterCutOff;
};

uniform PointLight pointLight;
uniform DirectionalLight directionalLight;
uniform DirectionalLight sunLight;
uniform SpotLight spotLight;
uniform int iLightType;