#version 330 core
#include "common/defines.glsl"
layout (triangles) in;
layout (line_strip, max_vertices = 18) out;

in VS_SHADER_OUT {
   vec3 normal;
   vec3 tangent;
   vec3 binormal;
   vec4 pos;
} VS_out[];


out GS_SHADER_OUT {
   vec4 color;
} GS_out;

const float MAGNITUDE = 0.1;

void GenerateLines(int index)
{
    GS_out.color = COLOR_BLUE;
    gl_Position = VS_out[index].pos;
    EmitVertex();
    gl_Position = VS_out[index].pos + vec4(VS_out[index].normal, 0.0) * MAGNITUDE;
    EmitVertex();
    EndPrimitive();

    GS_out.color = COLOR_RED;
    gl_Position = VS_out[index].pos;
    EmitVertex();
    gl_Position = VS_out[index].pos + vec4(VS_out[index].tangent, 0.0) * MAGNITUDE;
    EmitVertex();
    EndPrimitive();

    GS_out.color = COLOR_GREEN;
    gl_Position = VS_out[index].pos;
    EmitVertex();
    gl_Position = VS_out[index].pos + vec4(VS_out[index].binormal, 0.0) * MAGNITUDE;
    EmitVertex();
    EndPrimitive();
}

void main()
{
    GenerateLines(0); // first vertex normal
    GenerateLines(1); // second vertex normal
    GenerateLines(2); // third vertex normal
}