#version 330 core
#include "common/vsh_base.glsl"

out VS_SHADER_OUT {
    vec3 normal;
    vec3 tangent;
    vec3 binormal;
    vec4 pos;
} VS_out;

void main()
{
    mat3 normalMatrix = mat3(transpose(inverse(mViewModel)));
    VS_out.normal = normalize(vec3(mProjection * vec4(normalMatrix * vNormal, 1.0)));
    VS_out.tangent = normalize(vec3(mProjection * vec4(normalMatrix * vTangent, 1.0)));
    VS_out.binormal = normalize(vec3(mProjection * vec4(normalMatrix * vBinormal, 1.0)));
    VS_out.pos = mMVP * vec4(vPosition, 1.0);
    gl_Position = VS_out.pos;
}