#version 330
#include "common/defines.glsl"
#include "common/uniforms/material.glsl"
#include "common/vsh_base.glsl"
#include "common/structs/material.glsl"

out Vertex VS_out;

MaterialFlags materialFlags;

void main()
{
    //todo optimize with preprocessor function macros
    decodeMaterialFlags(material.iFlags, materialFlags);

    vec4 vPos4 = vec4(vPosition, 1.0);
    gl_Position = mMVP * vPos4;

    vec3 n = normalize(mNormal * vNormal);

    #ifdef BUMP_MAPPNING
    if (materialFlags.bUseNormalTexture) {
        vec3 t = normalize(mNormal * vTangent);
        vec3 b = normalize(mNormal * vBinormal);
        VS_out.mTBN = mat3(t,b,n);
    }
    #endif

    #ifdef PARALAX_MAPPNING
    if (materialFlags.bUseHeightTexture) {
        VS_out.mInvTBN = transpose(VS_out.mTBN);
    }
    #endif

    VS_out.vTexCoord = vTexCoord;
    VS_out.vPosition = (mModel * vPos4).xyz;
    VS_out.vRawPosition = vPosition;
    VS_out.vNormal = n;
}
