#version 330
#include "common/uniforms/textures.glsl"
#include "common/uniforms/material.glsl"
#include "common/structs/vertex.glsl"

uniform vec3 vViewPosition;
uniform float fViewDistance;

in Vertex GS_out;
out vec3 FS_out;

void main()
{
    vec4 diffuse = texture(textures.color, GS_out.vTexCoord);
    if (diffuse.a < 0.5) discard;

    diffuse *= material.fDiffuseIntensity;
    diffuse += material.vAmbient * material.fAmbientIntensity;

    FS_out = diffuse.xyz;
}

