#version 330
#include "common/defines.glsl"
#include "common/structs/vertex.glsl"

layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

uniform mat4 mCubeMapFaceTransforms[CUBE_MAP_NUM_OF_LAYERS];

out Vertex GS_out; // FragPos from GS (output per emitvertex)
in Vertex VS_out[];

void main()
{
    for(int face = 0; face < CUBE_MAP_NUM_OF_LAYERS; ++face)
    {
        gl_Layer = face; // built-in variable that specifies to which face we render.
        for(int i = 0; i < 3; ++i) // for each triangle's vertices
        {
            GS_out.vPosition = VS_out[i].vPosition;
            GS_out.vTexCoord = VS_out[i].vTexCoord;
            GS_out.vNormal = VS_out[i].vNormal;

            vec4 vPos4 = gl_in[i].gl_Position;
            gl_Position = mCubeMapFaceTransforms[face] * vPos4;
            EmitVertex();
        }
        EndPrimitive();
    }
}