#version 330 core
#include "common/uniforms/hdr_color_buffers.glsl"

in vec2 VS_out;
out vec4 FS_out;

void main()
{
    vec3 color = texture(hdrColorBuffers.color, VS_out).rgb;
    // Check whether result is higher than some threshold, if so, output as bloom threshold color
    float brightness = dot(color, vec3(0.2126, 0.7152, 0.0722));
    if(brightness > 1.0)
        FS_out = vec4(color, 1.0);
     else
        FS_out = vec4(0.0, 0.0, 0.0, 1.0);
}