#version 330 core
#include "common/uniforms/hdr_color_buffers.glsl"

out vec4 FS_out;
in vec2 VS_out;

uniform float exposure;

void main()
{
    const float gamma = 1f;
    vec3 hdrColor = texture(hdrColorBuffers.color, VS_out).rgb;
    vec3 bloomColor = texture(hdrColorBuffers.brightBlur, VS_out).rgb;

    hdrColor += bloomColor; // additive blending
    // tone mapping
    vec3 result = vec3(1.0) - exp(-hdrColor * exposure);
    // also gamma correct while we're at it
    result = pow(result, vec3(1.0 / gamma));
    FS_out = vec4(result, 1.0f);
}