#version 330 core
#include "common/uniforms/hdr_color_buffers.glsl"

out vec4 FS_out;
in vec2 VS_out;

uniform bool horizontal;
uniform float weight[5] = float[] (0.2270270270, 0.1945945946, 0.1216216216, 0.0540540541, 0.0162162162);

void main()
{
     vec2 tex_offset = 1.0 / textureSize(hdrColorBuffers.color, 0); // gets size of single texel
     vec3 result = texture(hdrColorBuffers.color, VS_out).rgb * weight[0];
     if(horizontal)
     {
         for(int i = 1; i < 5; ++i)
         {
            result += texture(hdrColorBuffers.color, VS_out + vec2(tex_offset.x * i, 0.0)).rgb * weight[i];
            result += texture(hdrColorBuffers.color, VS_out - vec2(tex_offset.x * i, 0.0)).rgb * weight[i];
         }
     }
     else
     {
         for(int i = 1; i < 5; ++i)
         {
             result += texture(hdrColorBuffers.color, VS_out + vec2(0.0, tex_offset.y * i)).rgb * weight[i];
             result += texture(hdrColorBuffers.color, VS_out - vec2(0.0, tex_offset.y * i)).rgb * weight[i];
         }
     }
     FS_out = vec4(result, 1.0);
}