#version 330
#include "common/defines.glsl"

layout (triangles) in;
layout (triangle_strip, max_vertices=18) out;

uniform mat4 mShadowCubeMapTransforms[CUBE_MAP_NUM_OF_LAYERS];

out vec3 GS_out; // FragPos from GS (output per emitvertex)

void main()
{
    for(int face = 0; face < CUBE_MAP_NUM_OF_LAYERS; ++face)
    {
        gl_Layer = face; // built-in variable that specifies to which face we render.
        for(int i = 0; i < 3; ++i) // for each triangle's vertices
        {
            vec4 vPos4 = gl_in[i].gl_Position;
            GS_out = vPos4.xyz;
            gl_Position = mShadowCubeMapTransforms[face] * vPos4;
            EmitVertex();
        }
        EndPrimitive();
    }
}